package com.ininwork.onechuan_plugin;

import android.app.Activity;
import android.content.ClipData;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.webkit.ConsoleMessage;
import android.webkit.ValueCallback;
import android.webkit.WebChromeClient;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.ProgressBar;
import android.widget.TextView;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.HashMap;
import java.util.Map;

public class WebViewActivity extends AppCompatActivity {

    WebView wv_main;
    TextView tv_title;

    ProgressBar pb_main;

//    @RequiresApi(api = 28)
//    public void webviewSetPath(Context context) {
//        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.P) {
//            String processName = getProcessName(context);
//            if (!MainProcessName.equals(processName)) {//判断不等于默认进程名称
//                WebView.setDataDirectorySuffix(processName);
//            }
//        }
//    }
//
//    public String getProcessName(Context context) {
//        if (context == null) return null;
//        ActivityManager manager = (ActivityManager) context.getSystemService(Context
//        .ACTIVITY_SERVICE);
//        for (ActivityManager.RunningAppProcessInfo processInfo : manager.getRunningAppProcesses
//        ()) {
//            if (processInfo.pid == android.os.Process.myPid()) {
//                return processInfo.processName;
//            }
//        }
//        return null;
//    }


    ValueCallback<Uri[]> mValueCallback;
    private int FILE_CHOOSER_REQUEST_CODE = 20001;
    private String currentTitle = "";
    String forceBack = "0";
    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.layout_webview);
        wv_main = findViewById(R.id.wv_main);
        pb_main = findViewById(R.id.pb_main);
        tv_title = findViewById(R.id.tv_title);
        Intent intent = getIntent();
        String jsonParameters = intent.getStringExtra("jsonParameters");

        try {
            JSONObject jsonObject = new JSONObject(jsonParameters);
            String url = jsonObject.getString("url");
//            String url = "https://jobs.51job.com/all/co114911.html";
//            String url = "http://gegefood.com";
//            String url = "http://www.sina.com.cn";
            String title = jsonObject.getString("title");

//            map["forceBack"]= "1";
            forceBack  = jsonObject.optString("forceBack");

            tv_title.setText(title);
            wv_main.getSettings().setJavaScriptEnabled(true);
            wv_main.getSettings().setDomStorageEnabled(true);

            wv_main.setWebChromeClient(new WebChromeClient() {
                @Override
                public void onReceivedTitle(WebView view, String title) {
                    super.onReceivedTitle(view, title);
                    currentTitle = title;
                    tv_title.setText(title);
                }

                @Override
                public boolean onConsoleMessage(ConsoleMessage consoleMessage) {
                    LogUtil.LogVMessage("进入consoleMessage");
                    return super.onConsoleMessage(consoleMessage);
                }

                @Override
                public void onProgressChanged(WebView view, int newProgress) {
                    super.onProgressChanged(view, newProgress);
                    LogUtil.LogVMessage("加载进度==》" + newProgress);
                }


//                public boolean onShowFileChooser(WebView webView, ValueCallback<Uri[]>
//                filePathCallback, FileChooserParams fileChooserParams) {
//                    return super.onShowFileChooser(webView, filePathCallback, fileChooserParams);
//                }

                //Android 5.0会调用这个
                @Override
                public boolean onShowFileChooser(WebView webView,
                                                 ValueCallback<Uri[]> filePathCallback,
                                                 FileChooserParams fileChooserParams) {
                    //确保没有现有的消息
//                    if (mValueCallback != null) {
//                        mValueCallback.onReceiveValue(null);
//                        mValueCallback = null;
//                    }
//                    mValueCallback = filePathCallback;
//                    if(filePathCallback!=null){
//                        filePathCallback.onReceiveValue();
//                    }
                    mValueCallback = filePathCallback;
                    openImageChooserActivity();
                    return true;
                }


            });


            wv_main.setWebViewClient(new WebViewClient() {
                String referer = "http://oapi.onechuan.com";

                @Override
                public void onPageStarted(WebView view, String url, Bitmap favicon) {
                    super.onPageStarted(view, url, favicon);
                    pb_main.setVisibility(View.VISIBLE);
                }

                @Override
                public void onPageFinished(WebView view, String url) {
                    super.onPageFinished(view, url);
                    pb_main.setVisibility(View.GONE);
                }

                @Override
                public boolean shouldOverrideUrlLoading(WebView view, String url) {
                    rememberUrl3 = rememberUrl2;
                    rememberUrl2 = rememberUrl1;
                    rememberUrl1 = currentUrl;
                    currentUrl = url;
//                    super.shouldOverrideUrlLoading()
                    boolean isAlipayInstall = isAliPayInstalled(WebViewActivity.this);
                    boolean isWebPage = url.startsWith("http:") || url.startsWith("https:");
                    LogUtil.LogVMessage("url==>" + url);
                    //处理支付宝逻辑
                    if (url.contains("alipay")) {
                        LogUtil.LogVMessage("url==>" + "进入alipay");
                        //尚未安装支付宝逻辑并且来的是网页链接

                        if (!isAlipayInstall && isWebPage) {
//                            ToastUtil.doShowToast(WebViewActivity.this, "尚未安装支付宝,使用网页版支付");
                            view.loadUrl(url);
                        }
                        //安装支付宝并且来的是打开app的连接
                        else if (isAlipayInstall && !isWebPage) {
                            Intent intent = new Intent(Intent.ACTION_VIEW,
                                    Uri.parse(url));
                            startActivity(intent);
                        } else {
                            view.loadUrl(url);
                        }
                        return true;
                    } else if (isWebPage) {
                        LogUtil.LogVMessage("进入else");
                        Map<String, String> extraHeaders = new HashMap<String, String>();
                        extraHeaders.put("Referer", referer);
                        view.loadUrl(url, extraHeaders);
                        referer = url;
                        return true;//不调用系统的浏览器打开网页
                    } else {
                        Intent intent = new Intent(Intent.ACTION_VIEW,
                                Uri.parse(url));
                        startActivity(intent);
                        return true;
                    }
                }
            });
            wv_main.loadUrl(url);
        } catch (JSONException e) {
            e.printStackTrace();
        }


    }

    private void openImageChooserActivity() {
        Intent i = new Intent(Intent.ACTION_GET_CONTENT);
        i.addCategory(Intent.CATEGORY_OPENABLE);
        i.setType("image/*");
        startActivityForResult(Intent.createChooser(i, "Image Chooser"), FILE_CHOOSER_REQUEST_CODE);
    }

    /**
     * 检测是否安装支付宝
     *
     * @param context
     * @return
     */
    public static boolean isAliPayInstalled(Context context) {
        Uri uri = Uri.parse("alipays://platformapi/startApp");
        Intent intent = new Intent(Intent.ACTION_VIEW, uri);
        ComponentName componentName = intent.resolveActivity(context.getPackageManager());
        return componentName != null;
    }

    public void doFinish(View view) {
        try {
            doBack();
        }
        catch (Exception e){
            finish();
        }
    }

    private String rememberUrl1;
    private String  rememberUrl2;
    private String  rememberUrl3;
    private  String currentUrl;

    private void doBack() {
        String originalUrl = wv_main.copyBackForwardList().getCurrentItem().getOriginalUrl();

        boolean circle1 = TextUtils.equals(rememberUrl1,currentUrl);
        boolean circle2 = (TextUtils.equals(currentUrl,rememberUrl2))&&(TextUtils.equals(rememberUrl1,rememberUrl3));

        if (TextUtils.equals("权益中心", currentTitle)) {
            finish();
        }
        else if(
                (originalUrl.equals(rememberUrl1)
                        ||
                        originalUrl.equals(rememberUrl1 + "/index")
                        ||    originalUrl.equals(rememberUrl1 + ".aspx")
                        || (originalUrl+ ".aspx").equals(rememberUrl1 )
                        || (originalUrl+ "/index").equals(rememberUrl1 )

                )){
            finish();
        }
        else if (wv_main.canGoBack() && !(circle1||circle2)){
            wv_main.goBack();
        }
        else {
            finish();
        }
    }

    //    @Override
//    public void onActivityResult(int requestCode, int resultCode, Intent data) {
//        super.onActivityResult(requestCode, resultCode, data);
//        if (requestCode == FILE_CHOOSER_REQUEST_CODE){
//            if (resultCode == Activity.RESULT_OK) {
//                WebUtils.seleteH5File(data, mValueCallback);
//            }
//        }
//    }
    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == FILE_CHOOSER_REQUEST_CODE) {
            if (resultCode == Activity.RESULT_OK) {
                WebUtils.seleteH5File(data, mValueCallback);
            } else {
                mValueCallback.onReceiveValue(null);
                mValueCallback = null;
            }
        }
    }

    static class WebUtils {

        public static void seleteH5File(Intent data, ValueCallback valueCallback) {
            if (valueCallback == null) {
                // todo valueCallback 为空的逻辑
                return;
            }
            try {
                Uri[] results = null;
                String dataString = data.getDataString();
                if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.JELLY_BEAN) {
                    ClipData clipData = data.getClipData();
                    if (clipData != null) {
                        results = new Uri[clipData.getItemCount()];
                        for (int i = 0; i < clipData.getItemCount(); i++) {
                            ClipData.Item item = clipData.getItemAt(i);
                            results[i] = item.getUri();
                        }
                    }
                }

                if (dataString != null) {
                    results = new Uri[]{Uri.parse(dataString)};
                    valueCallback.onReceiveValue(results);
                }
            } catch (Exception e) {
                valueCallback.onReceiveValue(null);
                e.printStackTrace();
            }
            valueCallback = null;
        }

    }

    @Override
    public void onBackPressed() {
        doBack();
    }
}
